;; appeared around 2000/04/11.
;; 2000/06/11 added option to lock generated divided paths.

(define (list-ref l n) (nth n l))

;; tail recursive definition.
(define (set-divided-paths img pname i size pdata l?)
  (let* ((len 0)
		 (oi (- i 2))
		 (j 0)
		 (data (cons-array 1 'double)))
	(while (and (< i size) (not (eq? (aref pdata i) 3.0)))
		   (set! len (+ 3 len))
		   (set! i (+ 3 i)))
	(set! data (cons-array len 'double))
	(while (< j len)
		   (aset data j (aref pdata oi))
		   (set! j (+ j 1))
		   (set! oi (+ oi 1))
		   (aset data j (aref pdata oi))
		   (set! j (+ j 1))
		   (set! oi (+ oi 1))
		   (if (eq? (aref pdata oi) 3.0)
				 (aset data j 1.0)
				 (aset data j (aref pdata oi)))
		   (set! j (+ j 1))
		   (set! oi (+ oi 1)))
	(gimp-path-set-points
	 img
	 (string-append pname " divided")
	 (car (gimp-path-get-points img pname))
	 len
	 data)
	(if (eq? l? TRUE)
		(gimp-path-set-locked img (car (gimp-path-get-current img)) 1))
	(if (< i size)
		(begin
		  (aset pdata i 1.0) ;; its no longer a disconnected component
		  (set-divided-paths img pname i size pdata l?)))))
  
(define (script-fu-path-divide img drw l?)
  (if (not (eq? (cadr (gimp-path-list img)) ()))
	  (let* ((current-pathname (car (gimp-path-get-current img)))
			 (current-path (gimp-path-get-points img current-pathname))
			 (path-data (list-ref current-path 3))
			 (size (length path-data))
			 (index 2) ;; look at point type, hehehe...
			 )
		(set-divided-paths img current-pathname index size path-data l?)
		(gimp-displays-flush img))))

(script-fu-register
 "script-fu-path-divide"
 "<Image>/Path ops./Divide Paths"
 "Divide disconnected path to multiple paths to connected components.
Optionally, you can lock divided paths."
 "FUJITA Yuji (yuji@bijutsubu.com)"
 "FUJITA Yuji"
 "2000/06/11"
 "*"
 SF-IMAGE "Image to draw" 0
 SF-DRAWABLE "Drawable to edit" 0
 SF-TOGGLE "Lock Divided Paths?" FALSE 
)
