;; first appeared on 4/1, 2000.
;; 4/10, 2000. added error handling in case there is no paths.
;; 2000/06/10 changed to flip all locked path.

(define (get-locked-pathname-list img)
  (let* ((i 0)
		 (plist (cadr (gimp-path-list img)))
		 (size (length plist))
		 (return ())
		 )
	(while (< i size)
		   (if (eq? 1 (car (gimp-path-get-locked img (nth i plist))))
			   (set! return (cons (nth i plist) return)))
		   (set! i (+ i 1)))
	return))

(define (list-ref l n) (nth n l))
;;
(define (flip-path-data path x y x? y?)
  (let* ((i 0)
		 (size (length path))
		 (fpath path)
		 )
	(while (< i size)
		   (if (eq? x? TRUE)
			   (aset fpath i (- (* 2 x) (aref path i)))
			   (aset fpath i (aref path i))
			   )
		   (set! i (+ i 1))
		   (if (eq? y? TRUE)
			   (aset fpath i (- (* 2 y) (aref path i)))
			   (aset fpath i (aref path i))
			   )
		   (set! i (+ i 1))
		   (aset fpath i (aref path i))
		   (set! i (+ i 1))
		   )
  	fpath  ;; this returns the path data array
	)
  )
	

(define (path-flip img pathn x? y?)
  (let* ((current-pathname pathn)
		 (path-data (gimp-path-get-points img current-pathname))
		 (path (list-ref path-data 3))
		 (x (/ (car (gimp-image-width img)) 2))
		 (y (/ (car (gimp-image-height img)) 2))
		 )
	(gimp-path-set-points img
						  (string-append current-pathname " flipped")
						  (list-ref path-data 0)
						  (list-ref path-data 2)
						  (flip-path-data path x y x? y?)
						  )))

(define (script-fu-path-flip img drw all? x? y?)
  (if (not (eq? (cadr (gimp-path-list img) ())))
	  (let* ((i 0)
			 (size 0)
			 (plist ()))
		(if (eq? all? TRUE)
			(set! plist (cadr (gimp-path-list img)))
			(if (eq? (get-locked-pathname-list img) ())
				(set! plist (cons (car (gimp-path-get-current img)) ()))
				(set! plist (get-locked-pathname-list img))))
		(set! size (length plist))
		(while (< i size)
			   (path-flip img (nth i plist) x? y?)
			   (set! i (+ i 1))))))

(script-fu-register
 "script-fu-path-flip"
 "<Image>/Path ops./Flip locked paths."
 "Flip locked paths. Pivot point is located to the center of the Image.
If there is no locked paths, currente path is operated."
 "FUJITA Yuji (yuji@wl.me.titech.ac.jp)"
 "FUJITA Yuji"
 "2000/06/10"
 "*"
 SF-IMAGE "Image to draw" 0
 SF-DRAWABLE "Drawable to edit" 0
 SF-TOGGLE "All? " FALSE
 SF-TOGGLE "flip X?" TRUE
 SF-TOGGLE "flip Y?" FALSE
)
