;; first appeared on 4/1, 2000.
;; 4/10, 2000. added error handling in case there is no paths.
;; 2000/06/10 changed to scale all locked paths.

(define (get-locked-pathname-list img)
  (let* ((i 0)
		 (plist (cadr (gimp-path-list img)))
		 (size (length plist))
		 (return ())
		 )
	(while (< i size)
		   (if (eq? 1 (car (gimp-path-get-locked img (nth i plist))))
			   (set! return (cons (nth i plist) return)))
		   (set! i (+ i 1)))
	return))


(define (list-ref l n) (nth n l))
;; s for scale. i for index of array
(define (scale-path-data path sx sy)
  (let* ((i 0)
	(size (length path))
	(spath path)
	)
	(while (< i size)
		   (aset spath i (* (aref path i) sx))
		   (set! i (+ i 1))
		   (aset spath i (* (aref path i) sy))
		   (set! i (+ i 1))
		   (aset spath i (aref path i))
		   (set! i (+ i 1))
		   )
	spath  ;; this returns the path data array
	)
  )

(define (path-scale img path same? xscale yscale)
  (let* ((pathname path)
		 (path-data (gimp-path-get-points img pathname))
		 (path (list-ref path-data 3))
		 (sx "hoge")
		 (sy "hoge")
		 )
	(if (eq? same? TRUE)
		(set! yscale xscale)
		)
	(print-to-string xscale sx)
	(print-to-string yscale sy)
    (gimp-path-set-points img
						  (string-append pathname " scaled" sx "," sy)
						  (list-ref path-data 0)
						  (list-ref path-data 2)
						  (scale-path-data path xscale yscale)
						  )))

(define (script-fu-path-scale img drw same? all? xscale yscale)
  (let* ((i 0)
		 (size 0)
		 (plist ()))
	(if (eq? all? TRUE)
		(set! plist (cadr (gimp-path-list img)))
		(if (eq? (get-locked-pathname-list img) ())
			(set! plist (cons (car (gimp-path-get-current img)) ()))
			(set! plist (get-locked-pathname-list img))))
	(set! size (length plist))
	(while (< i size)
		   (path-scale img (nth i plist) same? xscale yscale)
		   (set! i (+ i 1)))))

(script-fu-register
 "script-fu-path-scale"
 "<Image>/Path ops./Scale locked paths."
 "Scale locked paths. Pushing toggle button makes ignore input of Y and
process the path to the same scale value of X.
If there is no locked paths, current path is operated."
 "FUJITA Yuji (yuji@bijutsubu.com)"
 "FUJITA Yuji"
 "2000/06/10"
 "*"
 SF-IMAGE "Image to draw" 0
 SF-DRAWABLE "Drawable to edit" 0
 SF-TOGGLE "Make Y same scale to X ?" TRUE
 SF-TOGGLE "all ?" FALSE
 SF-VALUE "Scale X" "2.0"
 SF-VALUE "Scale Y" "2.0"
)
