(define (list-ref l n) (nth n l))
;; s for scale. i for index of array
(define (scale-path-data path sx sy)
  (let* ((i 0)
	(size (length path))
	(spath path))
	(while (< i size)
		   (aset spath i (* (aref path i) sx))
		   (set! i (+ i 1))
		   (aset spath i (* (aref path i) sy))
		   (set! i (+ i 1))
		   (aset spath i (aref path i))
		   (set! i (+ i 1))
		   )
	spath  ;; this returns the path data array
	))

(define (scale-path-list img cp? paths x y)
  (let* ((i 0) ;; index
		 (num (car paths))
		 (name-l (cadr paths))
		 (name (list-ref name-l i))
		 (path (gimp-path-get-points orig-img name)) ;; not from the copy.
		 )
	(while (< i num)
		   (set! name (list-ref name-l i))
		   (set! path (gimp-path-get-points orig-img name))
		   (if (eq? cp? TRUE)
			   (gimp-path-delete img name))
		   (gimp-path-set-points img
								 (string-append name " scaled")
								 (car path)
								 (list-ref path 2)
								 (scale-path-data (list-ref path 3) x y))
		   (set! i (+ i 1)))))

(define (script-fu-scale-image-with-path img drw cp? ur? dstwidth dstheight xratio yratio)
  (set! orig-img img) ;; hehehe...
  (let* ((height (car (gimp-image-height img)))
		 (width (car (gimp-image-width img)))
		 (paths (gimp-path-list img))
		 (xscale 0.0)
		 (yscale 0.0))
	(if (or
		 (and (eq? 0 (* xratio yratio)) (eq? 0 (+ xratio yratio)))
		 (and (eq? 0 (* dstheight dstwidth)) (eq? 0 (+ dstheight dstwidth))))
		(gimp-message "Set to proper values.")
		(begin
		  (if (eq? ur? TRUE)
			  (begin (if (eq? 0 (* xratio yratio))
						 (begin
						   (set! xscale (+ xratio yratio))
						   (set! yscale xscale))
						 (begin
						   (set! xscale xratio)
						   (set! yscale yratio)))
					 (set! dstwidth (* width xscale))
					 (set! dstheight (* height yscale)))
			  (begin (if (eq? 0 dstheight)
						 (set! dstheight (* height (/ dstwidth width)))
						 (if (eq? 0 dstwidth)
							 (set! dstwidth (* width (/ dstheight height)))))
					 (set! xscale (/ dstwidth width))
					 (set! yscale (/ dstheight height))))
		  (if (eq? cp? TRUE)
			  (begin
				(set! img (car (gimp-channel-ops-duplicate img)))
				(gimp-display-new img)))
		  (gimp-undo-push-group-start img)
		  (gimp-image-scale img dstwidth dstheight)
		  (if (not (eq? (cadr paths) ()))  ;; handle in case there is no path.
			  (scale-path-list img cp? paths xscale yscale))
		  (gimp-undo-push-group-end img)
		  (gimp-displays-flush)))))

(script-fu-register
 "script-fu-scale-image-with-path"
 "<Image>/Image/Scale Image with Paths.."
 "Scale image with all paths.
  The 2nd toggle button is for to use scale ratio rather than destination size, the input values of destination size will be ignored.
  To scale with aspect ratio kept, set destination size or scale ratio you wish to ignore to zero."
 "FUJITA Yuji (yuji@bijutsubu.com)"
 "FUJITA Yuji"
 "2000/05/23"
 "*"
 SF-IMAGE "Image to draw" 0
 SF-DRAWABLE "Drawable to edit" 0
 SF-TOGGLE "Make copy?" TRUE
 SF-TOGGLE "Use ratio (i.e. not destination size) ?" TRUE
 SF-VALUE "Destination width" "256"
 SF-VALUE "Destination height" "256"
 SF-VALUE "Width scale" "0.5"
 SF-VALUE "Height scale" "0.5"
)
